﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace WebApiDemo02.Controllers
{
    public class ValuesController : ApiController
    {

        private static readonly List<string> Data = InitList();

        private static List<string> InitList()
        {
            return new List<string>()
            {
                "value1", "value2"
            };
        }

        // GET api/values
        public IEnumerable<string> Get()
        {
            return Data;
        }

        // GET api/values/5
        public IHttpActionResult Get(int id)
        {
            if (id >= 0 && Data.Count > id)
            {
                return Ok(Data[id]);
            }

            return NotFound();
        }

        // POST api/values
        public IHttpActionResult Post([FromBody]string value)
        {
            if (string.IsNullOrWhiteSpace(value))
            {
                return BadRequest("IsNullOrWhiteSpace isnt allowed!");

            }
            Data.Add(value.Trim());
            return CreatedAtRoute("DefaultApi", new {id = Data.Count - 1 }, Data[Data.Count-1]);
        }

        // PUT api/values/5
        public IHttpActionResult Put(int id, [FromBody]string value)
        {
            if (id >= 0 && Data.Count > id)
            {
                if (string.IsNullOrWhiteSpace(value))
                {
                    return BadRequest("IsNullOrWhiteSpace isnt allowed!");
                }
                Data[id] = value.Trim();
                return StatusCode(HttpStatusCode.NoContent);
            }
            return NotFound();
        }

        // DELETE api/values/5
        public IHttpActionResult Delete(int id)
        {
            if (id >= 0 && Data.Count > id)
            {
                var value = Data[id]; 
                Data.RemoveAt(id);
                return Ok(value);
            }
            return NotFound();

        }
    }
}
